(use-modules (guix)
	     (guix build-system asdf)
	     (guix git-download)
	     ((guix licenses) #:prefix license:)
	     (gnu packages base)
	     (gnu packages lisp)
	     (gnu packages lisp-check))

(define vcs-file?
  (or (git-predicate (current-source-directory))
      (const #t)))

(package
  (name "cl-buchberger")
  (version "0.0.1")
  (source (local-file (current-source-directory)
		      #:recursive? #t #:select? vcs-file?))
  (build-system asdf-build-system/sbcl)
  (native-inputs
   (list which coreutils sbcl sbcl-fiasco))
  (synopsis "Common Lisp implementation of Buchberger's algorithm")
  (description
   "Common Lisp implementation of Buchberger's algorithm for the computation
of Gröbner bases.

This package computes Gröbner bases of ideals in multivariate polynomial rings
over the rationals.")
  (home-page "https://sr.ht/~jmbr/cl-buchberger")
  (license license:x11))
